<template>
  <div>
    <v-touch
      class="air"
      v-on:panstart="swipeleft()"
      v-on:panend="swiperight()"
      v-on:panmove="swiping($event)"
    >
      <img class="fan1" src="../assets/images/airConditioner/fan.webp" alt="" />
      <div class="air-bar">
        <v-touch
          v-for="(bar, index) in bars"
          :key="index"
          :class="[
            'bar',
            { 'bar-start': index === 0, 'bar-end': index === bars.length - 1 },
          ]"
          :style="{ opacity: bar.opacity, background: bar.bgColor }"
          :ref="'barRef_' + index"
        ></v-touch>
      </div>
      <img class="fan2" src="../assets/images/airConditioner/fan2.webp" alt="" />
    </v-touch>
  </div>
</template>

<script>
export default {
  data() {
    return {
      // startY: 0, // 记录滑动开始的X坐标
      // endY: 0, // 记录滑动结束的X坐标
      // topBoundary: 0, // 左边界
      // bottomBoundary: 0, // 右边界
      distance: 0,
      bars: [
        // 创建包含标签信息的数组
        {
          opacity: 1,
          bgColor: "rgb(228,228,229)",
          startY: 0,
          endY: 0,
          topBoundary: 0,
          bottomBoundary: 0,
        },
        {
          opacity: 1,
          bgColor: "rgb(228,228,229)",
          startY: 0,
          endY: 0,
          topBoundary: 0,
          bottomBoundary: 0,
        },
        {
          opacity: 1,
          bgColor: "rgb(228,228,229)",
          startY: 0,
          endY: 0,
          topBoundary: 0,
          bottomBoundary: 0,
        },
        {
          opacity: 1,
          bgColor: "rgb(228,228,229)",
          startY: 0,
          endY: 0,
          topBoundary: 0,
          bottomBoundary: 0,
        },
        {
          opacity: 1,
          bgColor: "rgb(228,228,229)",
          startY: 0,
          endY: 0,
          topBoundary: 0,
          bottomBoundary: 0,
        },
        {
          opacity: 1,
          bgColor: "rgb(228,228,229)",
          startY: 0,
          endY: 0,
          topBoundary: 0,
          bottomBoundary: 0,
        },
        {
          opacity: 1,
          bgColor: "rgb(228,228,229)",
          startY: 0,
          endY: 0,
          topBoundary: 0,
          bottomBoundary: 0,
        },

        // 可以根据需要添加更多标签信息
      ],
      start_move: false,
      end_index: 0,
    };
  },
  mounted() {
    for (let i = 0; i < 7; i++) {
      const componentRef = this.$refs["barRef_" + i];
      const element = componentRef[0].$el;
      const rect = element.getBoundingClientRect();
      // console.log(element)
      this.bars[i].startY = rect.top;
      this.bars[i].endY = rect.bottom;
      this.bars[i].topBoundary = rect.top;
      this.bars[i].bottomBoundary = rect.bottom;
      if (i === 0) {
        this.distance = rect.bottom - rect.top;
      }
    }
  },
  methods: {
    swipeleft() {
      this.start_move = true;
    },
    swiperight() {
      this.start_move = false;
    },
    swiping(event) {
      if (this.start_move) {
        const currentY = event.center.y;
        for (let i = 0; i < 7; i++) {
          if (
            currentY >= this.bars[i].topBoundary &&
            currentY <= this.bars[i].endY
          ) {
            this.bars[i].opacity = 0.3;
            this.bars[i].bgColor = "rgb(40,185,231)";
            // 计算最大滑动距离（右边界 - 左边界）
            const maxDeltaX =
              this.bars[i].bottomBoundary - this.bars[i].topBoundary;
            // 计算透明度的变化，确保在0到1之间
            this.bars[i].opacity = Math.min(
              1,
              Math.max(0.3, (currentY - this.bars[i].topBoundary) / maxDeltaX)
            );
            console.log("透明度正在变化:" + this.bars[i].opacity);
            // 更新起始X坐标，以便连续调节
            this.bars[i].startY = currentY;
          } else if (currentY > this.bars[i].bottomBoundary) {
            this.bars[i].opacity = 1;
            this.bars[i].bgColor = "rgb(40,185,231)";
            this.bars[i].startY = currentY;
          } else if (currentY < this.bars[i].topBoundary) {
            this.bars[i].opacity = 1;
            this.bars[i].bgColor = "rgb(228,228,229)";
            this.bars[i].startY = currentY;
          }
        }
      }
    },
  },
};
</script>

<style scoped>
.air {
  width: 750px;
  height: 100px;
  background: white;
  border-radius: 50px;
  display: flex;
  justify-content: center;
  align-items: center;
}

.air-bar {
  width: 620px;
  height: 32px;
  display: flex;
  background-color: transparent;
  position: relative;

  .bar.active {
    background-color: #50b1e0;
  }
}

.air-bar .bar {
  flex: 1;
  height: 100%;
  background-color: #d8d8d8;
  position: relative;
  border-right: 2px solid white;
}

.bar-start {
  border-radius: 15px 0 0 15px;
  margin-left: 20px;
}

.bar-end {
  border-radius: 0 15px 15px 0;
  margin-right: 20px;
}

.fan1 {
  width: 20px;
  height: 20px;
}
.fan2 {
  width: 30px;
  height: 30px;
}
</style>
